﻿Option Strict On
Imports System.Xml.Linq
Imports System.IO
Imports System.IO.IsolatedStorage
Imports System.Windows.Media.Imaging
Imports Microsoft.Phone

Public Class ImageInfo
    Property imageFileName As WriteableBitmap
    Property fileName As String
End Class
Partial Public Class DataShowPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("myPictures", "imageFileList.xml")
        Using myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
            Using reader As StreamReader = New StreamReader(myStream)
                Dim readXmldoc As String = reader.ReadToEnd
                'myStream.Close()
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim myImageInfo As New List(Of ImageInfo)

                For Each result In From c In doc.Descendants("fileName") Select c
                    Dim imageFilePath As String = Path.Combine("myPictures", result.Attribute("imageFileName").Value)
                    Dim imageStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                    Using stream As IsolatedStorageFileStream = imageStorage.OpenFile(imageFilePath, FileMode.Open, FileAccess.Read)
                        Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(stream)
                        With myImageInfo
                            .Add(New ImageInfo With {.imageFileName = imageSource,
                                                    .fileName = result.Value})
                        End With
                        'stream.Close()
                    End Using
                Next
                ListBox1.ItemsSource = myImageInfo
            End Using
        End Using

        MyBase.OnNavigatedTo(e)
    End Sub
End Class
