﻿Option Strict On
Imports Microsoft.Phone.Tasks
Imports System.Windows.Media.Imaging
Imports Microsoft.Phone
Imports System.IO.IsolatedStorage
Imports System.IO
Imports System.Xml.Linq
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim myCameraTask As CameraCaptureTask
    Dim imageByte As Byte()


    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        myCameraTask = New CameraCaptureTask
        AddHandler myCameraTask.Completed, Sub(resultSender As Object, resultArgs As PhotoResult)
                                               If resultArgs.TaskResult = TaskResult.OK Then
                                                   Dim myCompsite As New CompositeTransform
                                                   myCompsite.CenterX = 189
                                                   myCompsite.CenterY = 173
                                                   myCompsite.Rotation = 90

                                                   imageByte = New Byte(CInt(resultArgs.ChosenPhoto.Length)) {}
                                                   resultArgs.ChosenPhoto.Read(imageByte, 0, imageByte.Length)
                                                   resultArgs.ChosenPhoto.Seek(0, IO.SeekOrigin.Begin)
                                                   Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(resultArgs.ChosenPhoto)
                                                   Image.RenderTransform = myCompsite
                                                   Image.Source = imageSource
                                               Else
                                                   saveButton.IsEnabled = False
                                                   Exit Sub
                                               End If
                                           End Sub


        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim xmlFilePath As String = Path.Combine("myPictures", "imageFileList.xml")
        If storage.FileExists(xmlFilePath) = True Then
            ichiranButton.IsEnabled = True
        Else
            ichiranButton.IsEnabled = False
        End If
        MyBase.OnNavigatedTo(e)
    End Sub

    'カメラ起動
    Private Sub cameraButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles cameraButton.Click
        myCameraTask.Show()
        saveButton.IsEnabled = True
    End Sub

    '画像とテキストデータ保存
    Private Sub saveButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles saveButton.Click
        '画像の保存
        Dim imageFileName As String = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.DirectoryExists("myPictures") = False Then
            storage.CreateDirectory("myPictures")
        End If

        Dim filePath As String = Path.Combine("myPictures", imageFileName)
        Using myStream As IsolatedStorageFileStream = storage.CreateFile(filePath)
            myStream.Write(imageByte, 0, imageByte.Length)
            'myStream.Close()
        End Using

        'XMLファイルの保存
        Dim xmlStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim xmlFilePath As String = Path.Combine("myPictures", "imageFileList.xml")

        If xmlStorage.FileExists(xmlFilePath) = False Then
            Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                      <image>
                                          <fileName imageFileName=<%= imageFileName %>><%= commentTextBox.Text %></fileName>
                                      </image>
            Using xmlStream As IsolatedStorageFileStream = xmlStorage.CreateFile(xmlFilePath)
                'xmlStream.Close()
            End Using


            If xmlStorage.FileExists(xmlFilePath) = True Then
                Using xmlwriter As StreamWriter = New StreamWriter(xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write))
                    xmlwriter.Flush()
                    xmlwriter.Write(xmldoc.ToString)
                    'xmlwriter.Close()
                End Using
                MessageBox.Show("画像とXMLファイルを保存しました。")
            End If
        Else
            Dim xmlStream As IsolatedStorageFileStream = xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Read)
            Using xmlreader As StreamReader = New StreamReader(xmlStream)

                Dim readXmldoc As String = xmlreader.ReadToEnd
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim addXml As XElement = <fileName imageFileName=<%= imageFileName %>><%= commentTextBox.Text %></fileName>
                doc.Add(addXml)
                'xmlreader.Close()
                xmlStream.Close()

                If xmlStorage.FileExists(xmlFilePath) = True Then
                    Using xmlwriter As StreamWriter = New StreamWriter(storage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write))
                        xmlwriter.Flush()
                        xmlwriter.Write(doc.ToString)
                        'xmlwriter.Close()
                        MessageBox.Show("画像とXMLファイルを保存しました。")
                    End Using
                End If
            End Using
        End If
        ichiranButton.IsEnabled = True
        commentTextBox.Text = String.Empty
        Image.Source = Nothing
        saveButton.IsEnabled = False
    End Sub

    Private Sub ichiranButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles ichiranButton.Click
        NavigationService.Navigate(New Uri("/DataShowPage.xaml", UriKind.Relative))
    End Sub
End Class
